/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2018,2019
 */
Polymer({
	is: 'maximo-reservation-issue-flyout',
  	behaviors: [BaseComponent, ItemMaster],
  	listeners: {
  		'maximo-lookup-selected' : '_returnFromLookup',
  		'asset-removed' : '_enableNext',
		'maximo-qrcode-result' : '_returnQRcode',
		'maximo-qrcode-dialog-opened':'_adjustCamera'
    },
  	properties : {
  		record: {
    		type:Object,
  			value:{}
		},
		/**
	     * Set the Records in dialog 
	     */
		issueInventory: {
  			type: Object,
  			notify: true,
  			observer: '_setDefaultData'
  		}, 
  		issueItemRowRecord: {
  			type: Object,
  			notify: true,
  			observer: '_setRowData'
  		},
  		rotatingItem : {
    		type: Boolean,
    		value: false
    	},
    	rotassetslookupurl : {
    		type: String
    	},
    	rotassetsaddparams : {
    		type: String
    	},
    	issueqty : {
    		type: Number,
    		notify: true,
    		observer: '_setRotAssetBal'
    	},
    	msgIntervalSecs : {
    		type: Number,
    		value: 2,
    		readOnly: false
    	},
    	batchIssue : {
    		type: Boolean,
    		value: false
    	},
    	reservationIndex : {
    		type: Number,
    		value: 0
    	},
    	rotatingassets : {
            type : Array
     	},
		additionalparams : {
			type: Array,
			value: [],
			notify: true
		},
		wpItemId : {
			type: String
		}

	},
  	attached: function() {
  		if(this.flyoutOwner){
  			this.async(function(){
  				this._setRowStyles(this.flyoutOwner.selectedRow, $j(this).find('.reservationIssuefield'));
  				var selReservationCount = this.flyoutOwner.$.reservation_list_table.selectedRecords.length;
  		        if(this.reservationIndex === (selReservationCount - 1)) {
  					this.$.issue_batchreservation.label = $M.localize('uitext', 'mxapiinvres', 'issue');
  				}
  		        if(this.batchIssue) {
  		        	this.$.cancel_issue.label = $M.localize('uitext', 'mxapiinvres', 'exit');
  		        	this.$.currSelLabel.label = $M.localize('uitext','mxapiinvres','currentselection',[this.reservationIndex+1,selReservationCount])
  		        }
  				this._enableNext();
  			}, 100);
		}
	},
	
	ready: function() {
		this._refreshIssueTypeDomain();
	},
	
	_setDefaultData: function(){
		if(this.issueInventory){
			this.record = this.issueInventory;
			this.$.issuebin.value = this.record.inventory[0].matusetrans[0].binnum;
			this.$.issuelot.value = this.record.inventory[0].matusetrans[0].lotnum;
			this.$.binlotbalance.value = this.record.inventory[0].matusetrans[0].curbal;
			this.$.issuelocation.value = (this.record.oplocation && !(this.record.oplocation === '')) ? this.record.oplocation 
					: ((this.record.tostoreloc && !(this.record.tostoreloc === '')) ? this.record.tostoreloc : '');
			this.rotassetsaddparams = 'oslc.where=itemnum=%22'+this.record.itemnum+'%22 and location=%22'+this.record.location
										+'%22 and itemsetid=%22'+this.record.itemsetid+'%22 and siteid=%22'+this.record.siteid+'%22';
			if(this.record.conditioncode){
				this.rotassetsaddparams  = this.rotassetsaddparams + 'and conditioncode=%22'+this.record.conditioncode+'%22';
			}
			this.invbalancehref = this.record.inventory[0].localref+'/invbalances/zombie';
			this.locationaddparams = 'oslc.where=siteid=%22'+this.record.siteid+'%22';
			
			var issueResource = this.$.issueReservationResource;
			
			if(issueResource) {				
				issueResource.resourceUri = this.record.inventory[0].localref + '/invbalances/zombie/getlist~binnum?count=1';
				var bincount = 0;
				var self = this;
				issueResource.loadRecord().then(function(result){
					bincount = result.totalCount;
					issueResource.resourceUri = self.record.href;
					if(bincount<=1 && self.record.inventory[0].matusetrans[0].lotnum){
						self.$.issuelot._hasLookup = '';
						$j(self.$.issuelot).find('input').off('tap');
						$j(self.$.issuelotqr).find('.qrcode').hide('');
					}
					if((bincount<=1 && self.record.inventory[0].matusetrans[0].binnum) || 
					   (bincount===1 && !self.record.inventory[0].matusetrans[0].binnum)){
						self.$.issuebin._hasLookup = '';
						$j(self.$.issuebin).find('input').off('tap');
						$j(self.$.issuebinqr).find('.qrcode').hide('');
					}
				});	
			}
		}
	},
	/**
     * Set data of current row
     */	
	_setRowData: function(){
		if(this.issueItemRowRecord){
  			var rec = this.issueItemRowRecord;

			this.additionalparams.push('oslc.where=wonum=%22'+rec.wonum+'%22&internalvalues=1&ignorecollectionref=1');

			$M.toggleWait(true);
			var self = this;
			this.$.wpmaterial.refreshRecords().then(function(){
				
				if (self.wpmaterialData.length > 0) {
					
					self.$.issueReservationResource.resourceUri = self.wpmaterialData[0].href +
					"/wpmaterialtask?lean=1&collectioncount=1&oslc.select=itemnum%2Citemqty&oslc.where=itemnum=%22" + rec.itemnum +
					"%22&wonum=%22" + rec.wonum + "%22&addid=1";
					
					self.$.issueReservationResource.loadRecord().then(function(result){

						if(result.member.length > 0) {
							self.wpItemId = result.member[0]._id;
						}
					}, function(error) {
						$M.toggleWait(false);
					});
				}
			
				$M.toggleWait(false);

			}, function(error) {
				$M.toggleWait(false);
			});

  			this.$.issueRowRestype.label = rec.restype;
  			this.$.issueRowRequireddate.label = moment(rec.requireddate).format($M.getMaxauth().whoami.dateformat.toUpperCase());
  			this.$.issueRowWonum.label = rec.wogroup;
  			this.$.issueRowItemnum.label = rec.itemnum;
  			this.$.issueRowDescription.label = rec.description;
  			this.$.issueRowBinnum.label = rec.binnum;
  			this.$.issueRowReservedqty.label = rec.reservedqty;
  			this.rotatingItem = rec.item.rotating;
  			$j(this.$.locationwrapper).find('input').prop('readonly',true);
  			$j(this.$.lotwrapper).find('input').prop('readonly',true);
  			if(rec.item.rotating){
  				$j(this.$.locationwrapper).css('display','flex');
  				$j(this.$.memo).attr('max-width','260');
  				$j(this.$.balance_memo_wrapper).css('display', 'block');
  				$j(this.$.memo_wrapper).addClass('adjust-memo');
  				$j(this.$.issue_quantity).addClass('adjust-quantity');
  				$j(this.$.memo_wrapper).addClass('adjust-memo');
  				$j(this.$.issue_wrapper).addClass('container'); 				
  				$j(this.$.conditionbin_wrapper).addClass('adjust-condition-wrapper');
  				$j(this.$.conditionWrapper).addClass('adjust-condition');
  				this.$.issueqty.isDecimal=false;
  			} 
  			if(rec.item.lottype_maxvalue === 'NOLOT'){
				$j(this.$.bin_wrapper).find('.bin').addClass('adjust-bin');
				$j(this.$.issuelotqr).find('.qrcode').hide('');
  			}
  			if(rec.conditioncode){
  				$j(this.$.conditionWrapper).removeAttr('hidden');
  			}
  			this.$.issueqty.$.valueElement.value = parseFloat(rec.reservedqty);
  			this.issueqty = parseFloat(rec.reservedqty);
  			this.$.issueqty.value = this.issueqty;
  			this.rotassetslookupurl = this.issueItemRowRecord.inventory[0].matusetrans_collectionref+'/zombie';
  			this.locationhref = this.issueItemRowRecord.inventory[0].matusetrans_collectionref+'/zombie';
  		}
	},
	
	_hideLotWrapper: function(record) {
		return record.item.lottype_maxvalue === 'NOLOT';
	},
	
	_closeFlyout: function() {
		this.owner.close();
		if(this.batchIssue){
			this.flyoutOwner._exitMultiSelect();
		}
	},
	
	_issueReservation: function() {
		var reservedqty = this.record.reservedqty;
		var issueqty = parseFloat(this.$.issueqty.$.valueElement.value ? this.$.issueqty.$.valueElement.value : this.$.issueqty.value);
		var message = $M.localize('uitext','mxapiinvres','reservationissued',[issueqty, this.record.itemnum, this.record.inventory[0].issueunit]);
		var tableRow = $j('#reservation_list_reservation_list_table_tablerow_' + this.record.requestnum + '-' + this.record.storelocsiteid.replace(/ /g,"_"))[0];
		
		if(this.issueItemRowRecord.item.rotating) {
			this._issueRotatingReservation(this, reservedqty, tableRow, message);
		} else {
			this._issueNonRotatingReservation(this, reservedqty, tableRow, message);
		}		
	},
	
	_handleBatchIssue: function(){
		this.owner.close();
		$M.toggleWait(false);
		var selReservationCount = this.flyoutOwner.$.reservation_list_table.selectedRecords.length;
		if(this.reservationIndex < (selReservationCount - 1)){
			this.flyoutOwner.fire('display-next-reservation',{'reservationIndex': this.reservationIndex + 1});
		} else {
			this.flyoutOwner._exitMultiSelect();
		}
	},
	
	_issueRotatingReservation: function(self, reservedqty, tableRow, message) {
		var issueInv = {};
		var issueRotInv = [];
		var glAccountArr = [];
		var glDebitAcct = null;
		var selfobj = self;
		var location = this.$.issuelocation.value;
		var requestHeaders = {};
		var rotatingassets = $j(this).find('#rotatingAssetSelection')[0].rotatingassets;
		if(rotatingassets.length > 0) {
			rotatingassets.forEach(function(rotasset, index){
				issueInv = {};
				issueInv.inventory = [];
				issueInv.inventory[0] = {};
				issueInv.inventory[0].matusetrans = [];
				issueInv.inventory[0].matusetrans[0] = {};
				issueInv.href = self.record.href;
				issueInv.inventory[0].matusetrans[0].issuetype = self._getIssueTypeValue('issuetypeissue');
				issueInv.inventory[0].matusetrans[0].positivequantity = 1;
				issueInv.inventory[0].matusetrans[0].quantity = 1;
				issueInv.inventory[0].matusetrans[0].requestnum = self.record.requestnum;
				issueInv.inventory[0].matusetrans[0].itemnum = self.record.itemnum;
				issueInv.inventory[0].matusetrans[0].rotassetnum = rotatingassets[index].assetnum;
				issueInv.inventory[0].matusetrans[0].memo = self.$.memo.value;
				issueInv.inventory[0].matusetrans[0].refwo = self.record.wonum;
				issueInv.inventory[0].matusetrans[0].mrnum = self.record.mrnum;
				issueInv.inventory[0].matusetrans[0].mrlinenum = self.record.mrlinenum;
				issueInv.inventory[0].matusetrans[0].ponum = self.record.ponum;
				issueInv.inventory[0].matusetrans[0].polinenum = self.record.polinenum;
				issueInv.inventory[0].matusetrans[0].location = self.$.issuelocation.value ? self.$.issuelocation.value.trim() : self.record.issuelocation;
				issueInv.inventory[0].matusetrans[0].storeloc = self.record.location;
				issueInv._action = 'update';
				// issueInv.inventory[0].matusetrans[0].gldebitacct = (self.record.glaccount && !self.record.glaccount.includes('?')) ? self.record.glaccount : null;
				if(self.record.glaccount) {
					if(!self.record.glaccount.includes('?')) {
						glDebitAcct =  self.record.glaccount;
					} else {
						glAccountArr = self.record.glaccount.split("-");
						glAccountArr[2] = (self.record.inventory[0].matusetrans[0].gldebitacct) ? 
							self.record.inventory[0].matusetrans[0].gldebitacct.substr(self.record.inventory[0].matusetrans[0].gldebitacct.length - 3) : '???';
						glDebitAcct =  glAccountArr.join("-");			
					}
				}
				issueInv.inventory[0].matusetrans[0].gldebitacct = (glDebitAcct && !glDebitAcct.includes('?')) ? glDebitAcct : null;
				issueInv.inventory[0].matusetrans[0].wpitemid= (self.wpItemId) ? self.wpItemId : self.record.inventory[0].matusetrans[0].wpitemid;
				issueRotInv.push(issueInv);
			});
		}
		
		requestHeaders.allornothing = true;
		requestHeaders.method = 'BULK';
		self.$.issueReservationResource.resourceUri = self.record.href.slice(0,self.record.href.indexOf('mxapiinvres')+11);
		self.$.issueReservationResource.updateRecord(issueRotInv, '*', null, true, requestHeaders).then(
			function() {
				if(!selfobj.batchIssue) {
					selfobj._issueCallback(tableRow, message, selfobj);
				} else {
			        $M.notify(message);
			        selfobj._handleBatchIssue();
				}
			 }, function(error) {
				 $M.toggleWait(false);
				 if(error.request && error.request.response && error.request.response.Error && error.request.response.Error.message){
					 $M.notify(error.request.response.Error.message, $M.alerts.warn); 
				 }
		     	});
	},
	
	_issueNonRotatingReservation: function(self, reservedqty, tableRow, message) {
		var issueInv = {};
		issueInv.inventory = [];
		var glAccountArr = [];
		var glDebitAcct = null;
		issueInv.inventory[0] = {};
		issueInv.inventory[0].matusetrans = [];
		issueInv.inventory[0].matusetrans[0] = {};
		var selfobj = self;
		var issueqty = parseFloat(self.$.issueqty.$.valueElement.value ? self.$.issueqty.$.valueElement.value : self.$.issueqty.value);
		
		issueInv.requestnum = self.record.requestnum;
		issueInv.orgid = self.record.orgid;
		issueInv.itemnum = self.record.itemnum;
		issueInv.siteid = self.record.siteid;
		issueInv.restype = self.record.restype;
		issueInv.inventory[0].matusetrans[0].issuetype = self._getIssueTypeValue('issuetypeissue');
		issueInv.inventory[0].matusetrans[0].positivequantity = issueqty;
		issueInv.inventory[0].matusetrans[0].quantity = issueqty;
		issueInv.inventory[0].matusetrans[0].requestnum = self.record.requestnum;
		issueInv.inventory[0].matusetrans[0].itemnum = self.record.itemnum;
		issueInv.inventory[0].matusetrans[0].binnum = self.$.issuebin.value;
		issueInv.inventory[0].matusetrans[0].lotnum = self.$.issuelot.value;
		issueInv.inventory[0].matusetrans[0].memo = self.$.memo.value;
		issueInv.inventory[0].matusetrans[0].refwo = self.record.wonum;
		issueInv.inventory[0].matusetrans[0].mrnum = self.record.mrnum;
		issueInv.inventory[0].matusetrans[0].mrlinenum = self.record.mrlinenum;
		issueInv.inventory[0].matusetrans[0].ponum = self.record.ponum;
		issueInv.inventory[0].matusetrans[0].polinenum = self.record.polinenum;
		issueInv.inventory[0].matusetrans[0].location = (self.record.oplocation) ? self.record.oplocation : null;
		issueInv.inventory[0].matusetrans[0].storeloc = self.record.location;
		// issueInv.inventory[0].matusetrans[0].gldebitacct = (self.record.glaccount && !self.record.glaccount.includes('?')) ? self.record.glaccount : null;
		if(self.record.glaccount) {
			if(!self.record.glaccount.includes('?')) {
				glDebitAcct =  self.record.glaccount;
			} else {
				glAccountArr = self.record.glaccount.split("-");
				glAccountArr[2] = (self.record.inventory[0].matusetrans[0].gldebitacct) ?
					 self.record.inventory[0].matusetrans[0].gldebitacct.substr(self.record.inventory[0].matusetrans[0].gldebitacct.length - 3) : '???';
				glDebitAcct =  glAccountArr.join("-");		
			}
		}
		issueInv.inventory[0].matusetrans[0].gldebitacct = (glDebitAcct && !glDebitAcct.includes('?')) ? glDebitAcct : null;
		issueInv.inventory[0].matusetrans[0].wpitemid= (self.wpItemId) ? self.wpItemId : self.record.inventory[0].matusetrans[0].wpitemid;
		issueInv.inventory[0].matusetrans[0].conditioncode=self.record.conditioncode ? self.record.conditioncode : null;
		$M.toggleWait(true);
		self.$.issueReservationResource.resourceUri = self.record.href;
		self.$.issueReservationResource.updateRecord(issueInv, '*', true).then(
			function() {
				if(!selfobj.batchIssue) {
					selfobj._issueCallback(tableRow, message, selfobj);
				} else {
			        $M.notify(message);
			        selfobj._handleBatchIssue();
				}
			 }, function(error) {
				 $M.toggleWait(false);
				 if(error.request && error.request.response && error.request.response.Error && error.request.response.Error.message){
					 $M.notify(error.request.response.Error.message, $M.alerts.warn); 
				 }
		     	});
	},
	
	_setRotAssetBal: function() {
		var rotasset = $j('maximo-rotating-asset')[0];
		if(rotasset){
			rotasset.quantity = Math.round(this.issueqty);
			rotasset._setQuantity();
		}
		this._enableNext();
	},
	
	/**
	 *Prevent scroll to top after collection refresh
	 */
	_preventScrollToTop: function(e){
		var ironList = $j('maximo-reservation-list').find('#reservation_list_reservation_list_table iron-list')[0];
		ironList.scrollOffset = ironList._scrollTop;
	},
	
	/**
     * Enable/disable issue button
     */
	_enableNext : function(){
		var rec = this.issueItemRowRecord;
		if(rec) {
			var issueqty = parseFloat(this.issueqty);
			if(rec.item.rotating && $j('maximo-rotating-asset')[0]) {
					var selrotassetsno = $j('maximo-rotating-asset')[0].rotatingassets.length;
					if(issueqty > 0 && selrotassetsno === parseInt(issueqty) && this.$.issuelocation.value.trim() !== '') {
						this.batchIssue ? $j(this.$.issue_batchreservation).attr({'disabled': false}) : $j(this.$.issue_reservation).attr({'disabled': false});
					} else {
						this.batchIssue ? $j(this.$.issue_batchreservation).attr({'disabled': true}) : $j(this.$.issue_reservation).attr({'disabled': true});
					} 
			} else if(!rec.item.rotating) {
				if(issueqty > 0 && rec.item.lottype_maxvalue === 'NOLOT') {
					this.batchIssue ? $j(this.$.issue_batchreservation).attr({'disabled': false}) : $j(this.$.issue_reservation).attr({'disabled': false});
				} else if (issueqty > 0 && rec.item.lottype_maxvalue === 'LOT' 
							&& this.$.issuelot.value && this.$.issuelot.value.trim() !== ''){
					this.batchIssue ? $j(this.$.issue_batchreservation).attr({'disabled': false}) : $j(this.$.issue_reservation).attr({'disabled': false});
				} else {
					this.batchIssue ? $j(this.$.issue_batchreservation).attr({'disabled': true}) : $j(this.$.issue_reservation).attr({'disabled': true});
				}
			}
		}
	},
	
	_returnFromLookup : function(e){
		if(e.detail.identifier === 'issuebin' || e.detail.identifier === 'issuelot') {
			if(e.detail.records && e.detail.records.length > 0) {
				this.$.binlotbalance.value = e.detail.records[0].curbal;
			}
		}
		else if(e.detail.identifier==='selectrotatingasset'){
			this._appendConditionCode();
		}
		this._enableNext();
	},
	
	_issueCallback : function(tableRow, message, selfobj){
		var completeOverlay = function(){
			$M.getGlobalResource('reservationcollection').refreshRecords().then(function(){
				$M.toggleWait(false);
			});
		};
        selfobj.owner.close();
		var overLay =  $M.createOverlay(tableRow, message, completeOverlay,null,selfobj.msgIntervalSecs, selfobj.parentElement.parentElement, null, true);
		var undoOverlay = $j('#overlaybuttondivreservation_list_reservation_list_table_tablerow_' + selfobj.record.requestnum + '-' + selfobj.record.storelocsiteid)[0];
		$j(overLay).find(undoOverlay).remove();
		selfobj._preventScrollToTop();
	},
	
	_returnQRcode: function(event) {
		var self=this;
  		if(event.detail.identifier === 'issuebin'){
			self.$.issueReservationResource.loadRecord().then(function(result){
				if(result.inventory && result.inventory.length){
					var url=result.inventory[0].localref + '/invbalances/zombie';
  	  				 self._getIssueBinbarCodeVal(url,self,event);	
				}
  			});
  		}
  		
  		else if(event.detail.identifier === 'toRotate'){
			self.$.issueReservationResource.loadRecord().then(function(result){
				if(result.inventory && result.inventory.length){
					var url=self.issueItemRowRecord.inventory[0].matusetrans_collectionref+'/zombie';
  	  				 self._getIssueBinbarCodeVal(url,self,event);	

				}
  			});
  		}
  		else{
			self.$.issueReservationResource.loadRecord().then(function(result){
				if(result.inventory && result.inventory.length){
					var url=result.inventory[0].localref + '/invbalances/zombie';
  	  				 self._getIssueLotbarCodeVal(url,self,event);	
				}
  			});
  		}
	},
	_getIssueBinbarCodeVal:function(url,self,event){
		this.rotatingassets = [];
        var bincollection = Polymer.Base.create('maximo-collection', {
               'id':  'binCollection',
               'pageSize' : '1', 
        }); 
        
        var issuecomponent='';
        var issueLookup='';
        var maximoQbe = new MaximoQbe();
        
        if(event.detail.identifier === 'issuebin'){
               issuecomponent = $j(self.$.issuebin)[0];
               issueLookup = $M._lookups[issuecomponent._lookupObject.name];
            maximoQbe.setEquals('binnum',event.detail.value);
        }
        
        else if(event.detail.identifier==='toRotate'){
                 issueLookup = $M._lookups['rotatingasset'];
                maximoQbe.setEquals('assetnum',event.detail.value);
                maximoQbe.setEquals('conditioncode',this.record.conditioncode);
                maximoQbe.setEquals('itemnum',this.record.itemnum);
                maximoQbe.setEquals('location',this.record.location);
                maximoQbe.setEquals('itemsetid',this.record.itemsetid);
                maximoQbe.setEquals('siteid',this.record.siteid);
                if(this.record.conditioncode){
    				maximoQbe.setEquals('conditioncode',this.record.conditioncode);
                }
           }
        self.issueURI =  url+'/getlist~'+issueLookup.getList +'?oslc.select='+issueLookup.attributeNames;

        qbeObject = maximoQbe.toJSON();
        bincollection.queryWhere = qbeObject;         
        bincollection.collectionUri=self.issueURI;           
        bincollection.refreshRecords().then(function(record){      
        event.detail.records=[bincollection.collectionData[0]];           
        if(record.response.member.length>0){
               if(event.detail.identifier==='toRotate' && event.detail.records[0]!=undefined){
                   self.rotatingassets.push(event.detail.records[0]);
                   var exist=false;
                   
                   var rotatingassetArray= $j(self).find('#rotatingAssetSelection')[0].rotatingassets;
                   rotatingassetArray.forEach(function(item,index){
                       if(item.assetnum==self.rotatingassets[0].assetnum){
                            exist=true;
                            return exist;
                       }
                   });
                   
                   if(!exist){
                      $j(self).find('#rotatingAssetSelection')[0].rotatingassets.push(self.rotatingassets[0]); 
                   }

                   $j(self).find('maximo-datalist')[0].refresh();
                   $j(self).find('#rotatingAssetSelection')[0].selqty = rotatingassetArray.length;
                   $j(self).find('#rotatingAssetSelection')[0]._setQuantity();
               }
               else{
               event.detail.records=[bincollection.collectionData[0]];
               self.$.issuebin.value=event.detail.records[0].binnum;
               self._returnFromLookup(event);
               }
        }else{ 
               $M.notify($M.localize('uitext', 'mxapisr', 'NoResultsFound'), $M.alerts.warn);
        }
 });
 },

	_getIssueLotbarCodeVal:function(url,self,event){
		
		var lotCollection = Polymer.Base.create('maximo-collection', {
			'id':  'lotCollection',
			'pageSize' : '1', 
		}); 
		
		var issuecomponent = $j(self.$.issuelot)[0];
		var issueLookup = $M._lookups[issuecomponent._lookupObject.name];
    	self.issueURI =  url+'/getlist~'+issueLookup.getList +'?oslc.select='+issueLookup.attributeNames;
    
    	var maximoQbe = new MaximoQbe();
	    maximoQbe.setEquals('lotnum',event.detail.value);
		qbeObject = maximoQbe.toJSON();
		lotCollection.queryWhere = qbeObject;     	
		lotCollection.collectionUri=self.issueURI;    	
		lotCollection.refreshRecords().then(function(record){					
		if(record.response.member.length>0){
			event.detail.records=[lotCollection.collectionData[0]];
			self.$.issuelot.value=event.detail.records[0].lotnum;
			self._returnFromLookup(event);
		}else{ 
 			$M.notify($M.localize('uitext', 'mxapisr', 'NoResultsFound'), $M.alerts.warn);
		}
		self._enableNext();
	});
	},
		  		
	_setbalance : function(){
		return (!record.curbal || (record.curbal && record.curbal === 0)) ? 0 : record.curbal;
	},
	
	_setIssueqty : function(){
		this.issueqty = this.$.issueqty.$.valueElement.value? parseFloat(this.$.issueqty.$.valueElement.value, 10) : 0;
	},
	
	_setIssueValQty : function(){
		this.issueqty = this.$.issueqty.value? parseFloat(this.$.issueqty.value, 10) : 0;
	},
	
	_issueBatchReservation : function(){
		this._issueReservation();
	},
	
	_skipReservation : function(){
		this._handleBatchIssue();		
	},
	
	_adjustCamera:function(){
		$j('maximo-workscape').find('#flyout').css('z-index', '20000');
	},
	
	_appendConditionCode:function(){
		var rotatingAssetSelection = $j(this).find('#rotatingAssetSelection')[0];
		var dataListItems=$j(rotatingAssetSelection.$.rotating_asset_list.$.datalist).find('.datalistAttribute');
		dataListItems.css({ display: 'inline-block'});
		
		dataListItems.each(function(index,item) {
			if(item.dataset && item.dataset.attribute==='conditioncode' &&
					item.innerHTML!='&nbsp;'){
				item.prepend('(');
				item.append(')');
			}			
		});
	
	}
});

