/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2017
 */
Polymer({
	is: 'maximo-storeroomedit-dialog',
  	behaviors: [BaseComponent],
	listeners: {
  			
  		},
  	properties : {
  		/**
	     * Set the Records in dialog 
	     */
  		updateStoreData: {
  			type: Object,
  			notify: true,
  			observer: '_setDefaultVal'
  		},
  		flyoutWidth: {
  			type: String,
  			notify: true
  		},
  		flyoutTopOffset: {
  			type: String,
  			notify: true
  		}
  		
  	},
    /**
     * Apply validation on store field 
     */
  	_storeFieldsValidate: function(e){
		var saveStoreIcon = this.$.saveStoreIconOn;

		var storeRateVal = this.$.updatedStoreBalance.$.valueElement.value;	
			storeRateVal = parseFloat(parseFloat(storeRateVal).toFixed(2));
			
		var stdcost=this.$.stdcost.value;
		var avgcost=this.$.avgcost.value;
			
		if(storeRateVal >= 0 || stdcost>=0 || avgcost>=0){
			$j(saveStoreIcon).attr({'disabled': false});
		}else{
			$j(saveStoreIcon).attr({'disabled': true});
		}
	},
	_isNumber: function(e){
		 var evt = e;
		  var key = evt.keyCode || evt.which;		
		  key = String.fromCharCode( key );
		  var regex = /[-+]?[0-9]*[.,]?[0-9]+/;
		  if( evt.keyCode !== 8 && evt.keyCode !== 46 ){
			  if( !regex.test(key) ) {
				  evt.returnValue = false;
			    if(evt.preventDefault){
			    	evt.preventDefault();
			    }
			  }
		  } 
	},
	/**
     * Call validation method on every click
     */
	attached: function(e){
		var _self = this;
		$j(_self).find('.newbalancespinner input, .newbalancespinner .divAjust, .invcost-row input, .invcost-row .divAjust').on('keyup click',function(e){
			_self._storeFieldsValidate(e);
		});
		
		$j(_self).find('.newbalancespinner input, .newbalancespinner .divAjust, .invcost-row input, .invcost-row .divAjust').on('keypress',function(e){
			_self._isNumber(e);
		});
		
		$j(this.$.editStoreDialog).css({
			'width': this.flyoutWidth
		});
		
		 
		 if(window.navigator.userAgent.toLowerCase().indexOf('ipad') > -1){
			var last_h = $j(window).innerHeight(); //  store the initial height.
			
			var virtual_keyboardHeight = 423;
				if(/CriOS/.test(navigator.userAgent)){
					virtual_keyboardHeight = 466;
				}
			    $j(_self).find('.newbalancespinner input').on('click',function(e){
			    	if(window.innerHeight < window.innerWidth){
				    	virtual_keyboardHeight = 517;
				    }
			    	if(window.innerHeight < window.innerWidth && /CriOS/.test(navigator.userAgent)){
				    	virtual_keyboardHeight = 560;
				    }
					var flyOutHeight = $j(_self).closest('#flyout').css('top');
					flyOutHeight = parseFloat(flyOutHeight);
					this.flyoutTopOffset = flyOutHeight;
				   if((last_h - flyOutHeight) < virtual_keyboardHeight){
					  var virtualOffset = last_h - virtual_keyboardHeight;
					   $j(_self).closest('#flyout').css('top', virtualOffset + 'px');
				   }
				});
			    
				$j(_self).find('.newbalancespinner input').on('blur', function(){
					if(this.flyoutTopOffset){
						$j(_self).closest('#flyout').css('top',this.flyoutTopOffset + 'px');
					}
				});
			  
				window.onresize = function () {
					$j(_self).find('.newbalancespinner input').blur();
					_self.owner.close();
				};
		 }
		 
		 if(this.$.stdcost) {
				this.$.stdcost.label = $M.localize('uitext', 'mxapiitem', 'stdcost', [this.getCurrencyCode()]);
				this.$.stdcosttext.label = $M.localize('uitext', 'mxapiitem', 'stdcost', [this.getCurrencyCode()]);
			}
			if(this.$.avgcost) {
				this.$.avgcost.label = $M.localize('uitext', 'mxapiitem', 'avgcost', [this.getCurrencyCode()]);
				this.$.avgcosttext.label = $M.localize('uitext', 'mxapiitem', 'avgcost', [this.getCurrencyCode()]);
			}
		
	},
	/**
     * Set default value in dialog 
     */
  	_setDefaultVal: function(){
  		var _self = this;
  		if(this.updateStoreData){
  			var rec = this.updateStoreData;
  			this._returnInvCost(rec);
  			this.$.updateStoreRowId.label = rec.itemnum?rec.itemnum:rec.invitemnum;
  			this.$.updateStoreRowDesc.label = (rec.item && rec.item.description)?rec.item.description:rec.itemdescription;
  			this.$.updateStoreBin.label = rec.binnum?rec.binnum:rec.bincnt;
  			this.$.updateStoreLot.label = rec.lotnum?rec.lotnum:rec.lotcnt;
  			this.$.updateStoreCondition.label = rec.conditioncode?rec.conditioncode:'';
  			this.$.updateStoreBalance.label = rec.curbaltotal;
  			this.$.updatedStoreBalance.value = rec.curbaltotal;
  			if(!rec.conditioncode){
                $j(this).find('#stdcost_wrapperComponent').hide();
  				$j(this).find('#avgcost_wrapperComponent').hide();
  				$j(this).find('#stdcosttext_wrapper').hide();
  				$j(this).find('#avgcosttext_wrapper').hide();
  			}
  			else{
  				if(this.updateStoreData.costtype_maxvalue === 'LIFO' || this.updateStoreData.costtype_maxvalue === 'FIFO') {
  	  				$j(this).find('#stdcost_wrapperComponent').hide();
  	  				$j(this).find('#avgcost_wrapperComponent').hide();
  	  				$j(this.$.stdcost).find('input').attr('readonly', true);
  	  				$j(this.$.avgcost).find('input').attr('readonly', true);
  	  				$j(this).find('#stdcosttext_wrapper').show();
  	  				$j(this).find('#avgcosttext_wrapper').show();
  	  				$j(this).find('#stdcosttext').removeClass('hide-std-avg-cost');
  	  				$j(this).find('#avgcosttext').removeClass('hide-std-avg-cost');
  	  				this.$.updatedStoreBalance_text.value = rec.curbaltotal ? rec.curbaltotal : '0.0';
  	  			}else{
  	  				$j(this).find('#stdcost_wrapperComponent').show();
  	  				$j(this).find('#avgcost_wrapperComponent').show();
  	  				$j(this.$.stdcost).find('input').attr('readonly', false);
  	  				$j(this.$.avgcost).find('input').attr('readonly', false);
  	  				$j(this).find('#stdcosttext_wrapper').hide();
  	  				$j(this).find('#avgcosttext_wrapper').hide();
  	  				$j(this).find('#stdcost').removeClass('hide-std-avg-cost');
  	  				$j(this).find('#avgcost').removeClass('hide-std-avg-cost');		
  	  			}	
  			}
  		}
  		if(!$M.isMobile()){
	  		this.async(function(){
	  			$j(_self).find('.newbalancespinner input').focus();
			},300);
  		} 
  	},
  	/**
     * Close dialog 
     */
  	_flyoutClose: function(){
		this.owner.close();
	},
	_adjustBalance: function(invData){
		var self = this;
		  self.$.invBalanceResource.updateAction('wsmethod:adjustCurrentBalance',invData,'itemnum').then(function() {
              $M.getGlobalResource('storeroomdetailcollection').refreshRecords().then(function(){
                     $M.toggleWait(false);
                     self.owner.close();
              });
		                    
		   }, function(error) {
		          $M.showResponseError(error);
		          $M.toggleWait(false);
		          self.owner.close();
		   });
	},
	_createInvBalance: function(invData,newBalance){
		var self = this;
		var invBalance = {};
		  invBalance.newcurbal=parseFloat(newBalance);
		  invData.invbalances=[];
		  invData.invbalances[0]=invBalance;
		  self.$.invBalanceResource.updateRecord(invData,'*',true).then(function() {
			  
              $M.getGlobalResource('storeroomdetailcollection').refreshRecords().then(function(){
                     $M.toggleWait(false);
                     self.owner.close();
              });
		                    
		   }, function(error) {
		          $M.showResponseError(error);
		          $M.toggleWait(false);
		          self.owner.close();
		   });
	},
	_updateCrateSave:function(e){
		 var self = this;
		 $j(self).find('.newbalancespinner input').blur();
	        $M.toggleWait(true);
	        var hasInvBalance = false;
	        var invBalData =  this.updateStoreData;
	        var newBalance = 0;
	        if(this.$.updatedStoreBalance.value !== 0) {
	        	newBalance = this.$.updatedStoreBalance.value;
	        } 
	        if(invBalData.invbalances_collectionref){
	        	hasInvBalance = invBalData.invbalances && invBalData.invbalances.length===1;
	        }else{
	        	hasInvBalance = true;
	        }
	        if(hasInvBalance){
	        	 var confirmResourceUri;
	        	if(invBalData.invbalances && invBalData.invbalances.length===1){
	        		confirmResourceUri = invBalData.invbalances[0].localref;
	        	}else{
	        		confirmResourceUri = invBalData.localref;
	        	}
	        	invBalData.newBalance = newBalance.toString(); 
				invBalData.stdcost=parseFloat(this.$.stdcost.value);
				invBalData.avgcost=parseFloat(this.$.avgcost.value);	

	        	confirmResourceUri +='?editmode=1';
	 	        self.$.invBalanceResource.resourceUri = confirmResourceUri;
	 	        self._adjustBalance(invBalData);
	        }else{
	        	 self.$.invBalanceResource.resourceUri = invBalData.href;
				self._createInvBalance(invBalData,newBalance);
	        }
		 },
		 
		 _recordUpdatedSuccessHandler: function(e) {
			 $M.toggleWait(false);
				var targetResource = e.target;
				if (targetResource && targetResource.__data__ && targetResource.__data__.resourceData) {
					this.record = targetResource.__data__.resourceData;
				}
			},
		   
		_recordUpdatedErrorHandler: function(e) {
			    $M.toggleWait(false);
				if (this.targetelement) {
					this._setPreEditValues(this.targetelement);
				}
				var error = e.detail;
				if (error && error.request && error.request.response && error.request.response.Error) {
					$M.notify(error.request.response.Error.message, $M.alerts.error);
				}
		    },
		    
		  /**
		   * Fetch stdcost & avgcost value from record
		   */  
		 _returnInvCost: function(record){
			 var self=this;
			 var invcost=record.invcost ? record.invcost : [];
			 invcost.forEach(function(currentRecord) {
					if (currentRecord.conditioncode == record.conditioncode) {
						self.$.stdcost.value = currentRecord.stdcost_localized;
						self.$.avgcost.value = currentRecord.avgcost_localized;
					}
				});
		 }

		});
