/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2016,2018
 */


/*
 * 
A work center component.
 */
Polymer({
	is: 'maximo-workscape',
  	behaviors: [BaseComponent, WorkCenterCarouselBehavior,HTMLEncoder],
  	listeners: {
  		'app-drawer-transitioned' : '_appDrawerTransitioned',
  		'set-mobile-mode' : '_setMobileMode',
  		'maximo-navibar-mode': 'setNaviBarMode',
  		'maximo-botc': '_setBotcElements',
  		'designer-maximo-design-mode': '_edit',
  		'workscape-design-views': '_showIcons',
  		'workscape-show-view-mode': '_showConfirmViewMode',
  		'designer-pause' : '_designerPause',
  		'maximo-userprofile-listener': '_setUserProfileListener',
  		'maximo-userprofile-updated': '_nofifyUserProfileListener' 
  	},
  	properties: {
		/* is Mobile Mode */
		ismobile: {
			type: Boolean
		},
		_breadCrumb: {
			type: Object,
			value: function(){
				return {};
			}
		},
		_iframeWaitSrc: {
			type: String,
			value: ''
		},
		_showingIframe: {
			type: Boolean,
			value: false
		},
		_designerPaused: {
			type: Boolean,
			value: false
		},
		contextSubscriptions: {
			value: ['designer-pause']
		},
		_userProfileListener: {
			type: Array,
			value: []
		},
		/* Toggle back top button based on value */
		backTopHide: {
			type: Boolean,
			value: false
		} ,
		
  	},
   

  	ready: function(){
  		window.addEventListener('scroll', this.scrollFunction,true);
	},
  	
	
	scrollFunction: function(){
			if(event.target.id !== 'navigationmenu_menusection') {
				$j('#navigationmenu_menusection').hide();
				$j('#navigationmenu_outer').removeClass('open'); 
			}
		if(($M.currentWorkscape !== 'supervisor' && $M.currentWorkscape !== 'technician') || $M.workScape.backTopHide){
			return;
		}else{
			$M.workScape.toggleBackTopButton();
		}
	},
	
  	attached: function(){
  		
  		if($M.isMobile()){
  			$j(this.$.navBack).closest('div.west').prop('hidden', true);
  		}
  		if($M.inDesignMode()){
  			$M.toggleWait(true);
  			$M.lockWait = true;
  			var workscape = this;
  			if($M.isWCDesignEnabled()){
  				this.async(function(){
	  				workscape._edit(true);
	  				$M.lockWait = false;
	  				$M.toggleWait(false);
  				}, 500);
 			}
  			else {
  				$M.fire('designer-toggle-design-mode', false);
  				workscape._edit(false);
  				$M.lockWait = false;
  				$M.toggleWait(false);
  			}
  		}
  	},
  	/** 
	 * if a lookup was closed, call _closeLookup to clean it up 
	 */
  	_nofifyUserProfileListener: function(e){
  		if (this._userProfileListener){
		   this._userProfileListener.forEach(function(component){
				if( typeof component.userProfileRefreshed == 'function' ){ //not already loading next and has more page
					component.userProfileRefreshed(e.detail);
				}
           });
  		}
  		
  		this.$.usermenu.refreshImage();
  	
	},
	
	
  	/** 
	 * if a lookup was closed, call _closeLookup to clean it up 
	 */
  	_setUserProfileListener: function(e){
		if (this._userProfileListener == undefined){
			this._userProfileListener=[];
		}
		this._userProfileListener.push(e.detail);
	},
	
	
	/** 
	 * if a lookup was closed, call _closeLookup to clean it up 
	 */
	_appDrawerTransitioned: function(e){
		if ($M.lookup && e.target.opened === false){
			$M.lookup._closeLookup();
		}
	},
	
	/**  
	 * show/hide  the product name and page title. 
	 *
	 */
  	_setMobileMode: function(evt){
  		$j(this.$.titleDiv).attr({'hidden':evt.detail});
  		$j(this.$.productNameDiv).attr({'hidden':evt.detail});
  		this.ismobile = evt.detail;
  	},
  	
  	/**  
	 * show Masthead  when menu is set to hamburguer mode 
	 *
	 */
  	setNaviBarMode: function(evt){
  		$j(this.$.headerbar).toggleClass('headerMenuHamburguer',evt.detail.mode==='hamburger');
  	},

  	_hideAbout: function(){
  		return $M.isBotC();
  	},
  	
  	/**  
	 * update the product name if is botc enviroment 
	 *
	 */
  	_setBotcElements: function(){
  		if(this.$.maximoProductName){
  			this.$.maximoProductName.textContent = this.getProductName();
  		}
	},
  	
	_tpaeLoaded: function(){
		return $M._tpaeLoaded;
	},
	
	/*
	 * Can the internal application be closed? Save Required? Errors? 
	 */
	_canCloseTpaeApplication: function(drillEvent){
		$M.toggleWait(true);
		this.$.maximoIframe.contentWindow.postMessage({'close-tpae-iframe':true},'*');
	},
	
	/*
	 * Close tpae application within the internal iframe.
	 */
	_closeTpaeApplication: function(allowed){
		this.label = this._breadCrumb.TpaeApplication.title;
		document.body.style.overflowY = 'auto';
		var scrollTop = this._breadCrumb.WorkCenter.scrollTop;
		this.async(function(){
			$M.scrollTo(0,scrollTop);
			$j(this.$.maximoIframe).css({'top':scrollTop+'px'});
			$j(this.$.maximoIframe).css({'left':'100vw'});
			$j(this.$.footer).find('.footerToolbar')[0].style.display='initial';
			this.fire('tpae-close-application');
			this.label = this._breadCrumb.WorkCenter.title;
			this.$.navBack.select(0);
			$j(this.$.workscape).toggleClass('iframe', false);
			$M.publishEvent('tpae-iframe', false);
			this.async(function(){
				$M.scrollTo(0,scrollTop);
				$j(this.$.maximoIframe).css({'top':scrollTop+'px'});
				$j(this.$.maximoIframe).attr({'hidden':true,'src':this._iframeWaitSrc});
				this._handleDialogsForIframe(false);
			}, 50);
			if($M.dialogs.stack.length>0 && $M.inDesignMode()){
				this.async(function(){
					history.back(); //once for first iframe navigation
					history.back(); //once for iframe wait source
				}, 300);
			}
			if($M.inDesignMode()==true){
				$M.fire('designer-pause', (this._showingIframe = false));
			}
			$M.toggleWait(false);
			delete this._breadCrumb.TpaeApplication;
			delete this._breadCrumb.WorkCenter;
		}, 200);
	},
	
	/*
	 * Open a tpae application in lightningportalmode within the internal iframe.
	 */
	openTpaeApplication: function(link, uniqueId){
  		if(link){
	  		$M.toggleWait(true);
	  		if($M.inDesignMode()==true){
	  			$M.fire('designer-pause', (this._showingIframe = true));
	  		}
  			this._handleDialogsForIframe(true);
 			var maxauth = $M.getMaxauth();
  			var sessionid = maxauth._UISESSIONID_?'&uisessionid='+maxauth._UISESSIONID_:'';
  			var tpaeApplication = {'parentTitle':this.label, 'src':link+'&lightningportalmode=true'+sessionid};
			$M.notifyWithCustomTimeout(this.localize('uitext','mxapibase','tpae_save_warning'), $M.alerts.warn, 7);
			this._iframeWaitSrc = this.$.maximoIframe.src;
			//Updating src of iframe doesn't work for mobiles, like this.$.maximoIframe.src. Below works for all devices/browsers
			this.$.maximoIframe.contentDocument.location.replace(this.resolveUrl('wait.html'));
			
			this._breadCrumb.WorkCenter = {'title':this.label,'scrollTop':document.scrollingElement.scrollTop, 'uniqueId':uniqueId};
			
			$M.scrollTo(0,0);
			$j(this.$.maximoIframe).css({'top':'0px'});
  			document.body.style.overflowY = 'hidden';
    		
    		//Updating src of iframe doesn't work for mobiles, like this.$.maximoIframe.src. Below works for all devices/browsers			
			this.$.maximoIframe.contentDocument.location.replace(HTMLEncoder.sanitize(tpaeApplication.src));
    		
  			this._parentAppTitle = this.label;
  			
  			this.$.maximoIframe.removeAttribute('hidden');
  			
  			$j(this.$.workscape).toggleClass('iframe', true);
  			$M.publishEvent('tpae-iframe', true);

  			this.async(function(){
  				$j(this.$.footer).find('.footerToolbar')[0].style.display='none';
  	  			this.$.navBack.select(1);
  				$j(this.$.maximoIframe).css({'left':'0px'});
  			}, 200);
  			
    		this._breadCrumb.TpaeApplication = tpaeApplication;
  		}
  	},
	
  	/*
  	 * Hides and shows dialogs that were open when user opens a tpae app in the iframe
  	 */
	_handleDialogsForIframe: function(hide){
		var func = hide?'hide':'show';
		Object.keys($M.dialogs.map).forEach(function(key){
			var dialog = $M.dialogs.map[key];
			$j(dialog.$.underlay)[func]();
			$j(dialog.$.wrapper)[func]();
		})	;
	},
	
	/*
  	 * Scroll back to body top when clicked.
  	 */
	backToTop: function(){
		var backTop = $j(this.$.footer).find('.backTop');
		$j(backTop).click(function(e){
			e.preventDefault();
			$j('body,html').animate({
				scrollTop: 0
			}, 'slow');
			return false;
		});	
	},

	/*
	 * Handle maximize icons in design mode and non design mode
	 */
	handleMaximizeIcons: function(editFlag){
		var iconArr = document && document.querySelectorAll('[id^="workscape-"][id$="_maximizeIcon"]');
        if (iconArr){
            for (var i = 0; i < iconArr.length; i++) {
                if (iconArr[i]) {
                    iconArr[i].style.display = (editFlag) ? 'none' : 'block';
                }
            }
        }	
	},

	/**
	 * Triggered when edit button is clicked
	 * Enables/Disables CTRL hotkey listener
	 * Prevent clicks from executing events
	 */
    _edit: function(edit){
    	var ctrlKeyOn = function(event) {
			if (event.keyCode===17) {
				$j(document).find('.editmode').toggleClass('altEditMode',true);
				$j(document).find('.editmodeoutline').toggleClass('altEditMode',true);
			}
		};
		
		var ctrlKeyOff = function(event) {
			if (event.keyCode===17) {
				$j(document).find('.editmode').toggleClass('altEditMode',false);
				$j(document).find('.editmodeoutline').toggleClass('altEditMode',false);
			}
		};
    	
		//show editable fields when user clicks ctrl button on keyboard
		var ctrlKey = function(enable){
			if (enable){
				document.addEventListener('keydown', ctrlKeyOn);
				document.addEventListener('keyup', ctrlKeyOff);
			} else {
				document.removeEventListener('keydown', ctrlKeyOn);
				document.removeEventListener('keyup', ctrlKeyOff);
			}
		};
		
		if(edit){
			this.handleMaximizeIcons(edit);
			document.addEventListener('mousedown', this._blockClick(), true);
			ctrlKey(true);
			this._showDesignButton('view');
		} 
		else {
			this.handleMaximizeIcons(edit);
			document.removeEventListener('mousedown', this._blockClick(), true);
			ctrlKey(false);
			this._showDesignButton('design');
		}

		this._showEdit = edit;
		

		$M.fire('designer-design-mode-changed', edit); 
    	this._toggleHeaderFooterEnabled(edit);
    	
    	//In addition to finding all the isConfigurable() components, walk the workscape and find the enable-edit items
    	this._toggleHilightingForWorkscapeItems();
    },
    
    _toggleHeaderFooterEnabled: function(showEdit){
  		$j(this.$.headerbar).find('.east').find('*[data-maximocomponent]').each(function(){
   			this.childNodes.forEach(function(node){
   				if(node.nodeType === 1){
   					$j(node).toggleClass('editorDisabled', showEdit);
   				}
   			});
   		});	
  		$j(this.$.footer).find('.east').find('*[data-maximocomponent]').each(function(){
   			this.childNodes.forEach(function(node){
   				if(node.nodeType === 1){
   					$j(node).toggleClass('editorDisabled', showEdit);
   				}
   			});
   		});
    },
    
    _toggleHilightingForWorkscapeItems: function(){
    	
		this.async(function(){
			var count = $j(this).find('[enable-edit]').length;
			var idx = 0;
			do{
				var elem = $j(this).find('[enable-edit]')[idx];
				var hiliteElemId = elem.highlightElement;
				var hiliteElem = elem;
				if(hiliteElemId){
					//if id is specified, get that element and use it instead of base element
					hiliteElem = $j(elem).find('[data-scope-id='+hiliteElemId+']')[0];
					if(!hiliteElem){
						//if if couldn't find the actual element, revert back to the base element
						hiliteElem = elem;
					}
				}
				$j(hiliteElem).toggleClass('editmodeoutline',this._showEdit);
				idx++;
			}
			while (idx<count);
		},50);
    },
    
    /**
     * Handle the visibility of the edit icon
     * 
     * @return false - when using mobile device or  if browser is not chrome
     * @return true  - Hide icon
     */
    _showEditIcon: function(){
    	var is_chrome = /chrome/i.test( navigator.userAgent ) && !/edge/i.test( navigator.userAgent );
    	
    	var maxAuth = $M.getMaxauth();
    	
    	if(this._designerPaused){
    		return false;
    	}
    	
    	if(($M.checkSigoptions('MXAPICOMPONENT:SAVE') === false || $M.checkSigoptions('DESIGN') === false) || 
    			$M.isMobile() || !is_chrome || (maxAuth && maxAuth.whoami && maxAuth.whoami.baseLang !== maxAuth.whoami.langcode)){ //only show on chrome desktop and in base language
    		return false;
    	}
		if($M.isWCDesignEnabled()){
			if (!this.id.startsWith('workscape_designMode')){
				return true;
			} 
		}
		else {
			return false;
		}
    },

	_showConfirmMode: function(){
		if(!this._showEdit){
			 $M.fire('designer-toggle-design-mode');
		} 
		else {
			var dialog = $M.showDialog(null, 'manageWorkcenterDialog', $M.localize('uitext','mxapibase','manageWorkcenterDialog'), 'maximo-manage-workcenter', false, null);
			if(dialog){
                var dialogCloseButton = dialog.$.dialogCloseButton;
				 if (dialogCloseButton){
					 dialogCloseButton.addEventListener("click", function(){ 
						 document.addEventListener('mousedown', $M.workScape._blockClick(), true);
					 });
				 }	 
		     }
		 }
	},  

	
	/**
	 * Triggered when Top Level views - to show Edit Icon
	 */
    _showIcons: function(design){
    	$j(this.$.designModeButton).attr({'hidden': (!this._showEditIcon() || !design.detail.hasDesignMode)});
    },
    
    _computeDesignIcon: function() {
        if ( !$M.isMobile()){
	    		if($M.isWCDesignEnabled()){
	    			  if (!this.id.startsWith('workscape_designMode')){
	    				  $j(this.$.designModeButton).attr({'title': $M.localize('uitext','mxapicomponent','designModeHover')});	
	    				  return 'Maximo:Edit';
		    	      } 
	    		} else {
	    			this.removeEventListener('mousedown', this._blockClick());
	    			$j(this.$.designModeButton).attr({'title': $M.localize('uitext','mxapicomponent','manageModeHover')});
	    			return 'Maximo:View';
	    		}
		}		
     },
     
     _showdesignModeOnLabel: function(){
     	if (!$M.isMobile()){
     		if($M.isWCDesignEnabled()){
			    if (!this.id.startsWith('workscape_designMode')){
	    		    	return false;
	    	    }else{
	    		  return true;
	    	    } 
		  	} else {
		  		return false;
		  	}
     	}
     },	

     
     _showDesignButton: function(button){
    	if (button == 'design'){
			$j(this.$.designModeOnLabel).attr({'hidden':true});			
			$j(this.$.designModeButton).attr({'icon':'Maximo:Edit'});
			$j(this.$.designModeButton).attr({'title': $M.localize('uitext','mxapicomponent','designModeHover')});
			 
			if ($M.currentWorkscape == 'supervisor'){
				 this._hideNavBar(false);
			}
    	};
    	if (button == 'view'){
			$j(this.$.designModeOnLabel).attr({'hidden':false});
			$j(this.$.designModeButton).attr({'icon':'Maximo:Manage'});
			$j(this.$.designModeButton).attr({'title': $M.localize('uitext','mxapicomponent','manageModeHover')});
			
			if ($M.currentWorkscape == 'supervisor'){
				 this._hideNavBar(true);
			}
    	}; 
    	 
     },
     
     
     _hideNavBar: function(hideNavBar){
    	 if(hideNavBar){
			 $M.publishEvent('hide-navbar');
		 } else{
			 $M.publishEvent('show-navbar');
		 } 
     },
     
     /**
      * Handle the visibility of the 'About' Button
      * Button will be hidden when user is in design mode
      * 
      * @param designMode Flag that determines whether design mode is on
      */
     _showAboutButton: function(designMode){
    	$j(this.$.about).attr({'hidden': designMode});  	 
     },
	
     _designerPause: function(e){
    	 this._designerPaused = e.detail;
     },
     /**
	  * Show/hide back top button based on device type and scroll position.
	  */
     toggleBackTopButton: function(){
    	 $M.workScape.querySelector('.backTop').classList.add('hide');
	 	 if(this.backTopHide){
    		 return;
    	 }
		 if($M.isMobile()){
			if($j(window).scrollTop() >= 100){
				$M.workScape.querySelector('.backTop').classList.add('show');
				$M.workScape.querySelector('.backTop').classList.remove('hide');
			}else{
				$M.workScape.querySelector('.backTop').classList.remove('show');
				$M.workScape.querySelector('.backTop').classList.add('hide');
			}
		}
     }
	
});
